# RPC Broker Development Kit - Patch XWB\*1.1\*73

## Description

Patch XWB\*1.1\*73 RPC Broker Development Kit (BDK) with support for Delphi
XE8, 10, 10.1, 10.2, 10.3, and 10.4

XWB\*1.1\*73 corrects the following:

o When a user assigned more than one division in VistA selects the
division they will be working with in the Brokerx.User.Division field
is populated with the selected division, however, the division is only
identified by its number, the correct return should be 
IEN^SITENAME^SITEID, this patch ensures the data placed into the 
Brokerx.User.Division field is correctly formatted.
 
o Users are reporting that the default certificate for connection to
VistA is not correct.  Patches XWB*1.1*71 and XWB*1.1*72 addressed
certificate processing, however, the user would have to ensure they
were selecting the correct certificate from the list presented.  This
causes confusion if the list presented does not default to the 
certificate used for authenticating to VistA.  This patch has
redesigned the method of certificate processing, selecting the user's
Authentication certificate automatically, eliminating the need for the
user to select from a list of certificates.

o A new property has been added to the TRPCBroker component, the
property, named ShowCertDialog, is of type Boolean and defaults to
False.  If set to true, either at design time or at run time, the
user will be prompted to select a certificate rather than one being
auto-selected.  This was requested considering the auto-selection 
process, many applications have various components which require
different user attributes to successfully test, this new property
affords the software developer with the ability to show the
selection dialog to the user who can cancel it and be presented
with the Access/Verify code dialog.


## Product

- Product Name: RPC Broker Development Kit (BDK)
- Product Line Portfolio:

### Team Contacts

redacted
redacted - VistA Infrastructure team


- Maintained by: redacted
- Project Manager:  redacted
- Technical Team Lead:
- Configuration Manager:




## Code Description

The RPC Broker Development Kit (BDK) is a framework designed to be used by applications which require
a network connection to a VistA instance.  This framework provides connectivity to Remote Procedures
which are executed on the VistA server, the result of which is sent back to the calling application.
The framework also provides a secure mechanism for user authentication, using Identity and Access
Management (IAM) SAML tokens which are requested via the user's PIV card and passed into the VistA
instance for logging on.


### Deployment

Since the BDK is a framework, there is no deployment, the software developer who desires to use the BDK's
functionality simply loads the components into RAD Studio/Delphi, there is also a DLL for those who wish
to use another development platform/language such as C# or Visual Basic.  

#### Branching strategy

**UPDATE THIS FOR YOUR PROJECT AND BUILD STRATEGY**

Certain branches are special, and would ordinarily be deployed to various test environments:

- master: our default branch, for production-ready code. Master is always deployable. In our case, however, deployment does not happen automatically.
- pre-prod: code destined for the pre-production test server. This code might be deployed by hand or automatically, depending on the project and availability of a CI/CD solution.
- test: code that would probably autotmatically be pushed to a test or staging server. Again, in our case we don't do this -- but test deployment tasks like this are ideally automated with a CI/CD solution like Jenkins.

New code should be produced on a feature branch [following GitHub flow](redacted). Most often, you'll want to branch from **master**, since that's the latest in production. File a pull request to merge into **test**, which can be deployed to our testing environment.



### Testing

All testing of the code contained in the BDK is performed by software developers within the organization.


### Installing

Installation of the components is performed in the standard RAD Studio/Delphi way, there is a README file
included with the patch which details the proper installation method.



### License

All code is freely available to anyone desiring to use it, the version which is available outside the VA does not
include certain aspects of the BDK, such as ciphers and code which is aimed at authentication.
