// VISTA Remote Procedure Call Broker DLL interface
// Version 1.1P65 by HGW - Oct 14, 2016
// C++ Class Library Implementation

// DLL name
const char bapiDll[] = "BAPI32.DLL";

// Additional variables
HINSTANCE hLib;
enum TParamType { literal, reference, list } ParamType;

#if defined(__BORLANDC__)
   const char toolSet[] = "Borland C++";
#elif defined(_MSC_VER)
   const char toolSet[] = "Visual C++";
#else
   const char toolSet[] = "Unknown tool set";
#endif

// Header file with DLL function prototypes
void * 		(__stdcall *iMySsoToken)(void);
void * 		(__stdcall *iRPCBCreate)(void);
void 		   (__stdcall *iRPCBFree)(void *);
char *      (__stdcall *iRPCBCall) (void *, char *);
bool        (__stdcall *iRPCBCreateContext) (void *, char *);
void        (__stdcall *iRPCBMultSet) (void *, int, char *, char *);
void        (__stdcall *iRPCBParamGet) (void *, int, int, char *);
void        (__stdcall *iRPCBParamSet) (void *, int, int, char *);
void        (__stdcall *iRPCBPropGet) (void *, char *, char *);
void        (__stdcall *iRPCBPropSet) (void *, char *, char *);
void			(__stdcall *iRPCBMultItemGet) (void *, int, char *, char *);
void			(__stdcall *iRPCBMultPropGet) (void *, int, char *, char *);
void			(__stdcall *iRPCBMultSortedSet) (void *, int, bool);


//********************  new properties and methods  ************************

void			(__stdcall *iRPCBLoginPropGet) (void *, char *, char *);
void			(__stdcall *iRPCBLoginPropSet) (void *, char *, char *);
void			(__stdcall *iRPCBUserPropGet) (void *, char *, char *);
void			(__stdcall *iRPCBUserPropSet) (void *, char *, char *);
void			(__stdcall *iRPCBMultOrder) (void *, int, char *, int, char *);
void			(__stdcall *iRPCBMultSubscrip) (void *, int, int, char *);
void			(__stdcall *iRPCBMultPosition) (void *, int, char *, int);
bool			(__stdcall *iRPCBSilentLogin) (void *);
void			(__stdcall *iRPCBGetUserInfo) (void *);
void			(__stdcall *iRPCBStartProgSLogin) (char *, void *);
bool			(__stdcall *iRPCBCheckCmdLine) (void *);
void			(__stdcall *iRPCBGetServerInfo) (char *, char *, int);
void			(__stdcall *iRPCBPiece) (char *, char *, int, char *);
void			(__stdcall *iRPCBTranslate) (char *, char *, char *, char *);
void            (__stdcall *iRPCBEncode) (char *, char *);
void            (__stdcall *iRPCBDecode) (char *, char *);




char * TRPCBroker::RPCBCall( char * s)
{
	return iRPCBCall( pRPC, s);
}

bool TRPCBroker::RPCBCreateContext ( char * s)
{
	return iRPCBCreateContext( pRPC, s);
}

void TRPCBroker::RPCBMultSet ( int i, char * s, char * t)
{
	iRPCBMultSet(pRPC, i, s, t);
}

void TRPCBroker::RPCBParamGet ( int i, int j, char * s)
{
	iRPCBParamGet(pRPC, i, j, s);
}

void TRPCBroker::RPCBParamSet ( int i, int j, char * s)
{
	iRPCBParamSet(pRPC, i, j, s);
}

void TRPCBroker::RPCBPropGet ( char * s, char * t)
{
	iRPCBPropGet(pRPC, s, t);
}

void TRPCBroker::RPCBPropSet ( char * s, char * t)
{
	iRPCBPropSet( pRPC, s, t);
}

void TRPCBroker::RPCBMultItemGet ( int i, char * s, char * t)
{
    iRPCMultItemGet( pRPC, i, s, t);
}

void TRPCBroker::RPCBMultPropGet ( int i , char * s, char * t);
{
    iRPCMultPropGet( pRPC, i, s, t);
}

void TRPCBroker::RPCBMultSortedSet ( int i, bool v);
{
    iRPCBMultSortedSet( pRPC, i, v);
}


void TRPCBroker::RPCBLoginPropGet (char * s, char * t);
{
    iRPCBLoginPropGet( pRPC, s, t);
}

void TRPCBroker::RPCBLoginPropSet (char * s, char * t);
{
    iPRCBLoginPropSet( pRPC, s, t);
}

void TRPCBroker::RPCBUserPropGet (char * s, char * t);
{
    iRPCBUserPropGet( pRPC, s, t);
}

void TRPCBroker::RPCBUserPropSet (char * s, char * t);
{
    iRPCBUserPropSet( pRPC, s, t);
}

void TRPCBroker::RPCBMultOrder (int i, char *s, int j, char * t);
{
    iRPCBMultOrder( pRPC, i, s, j, t);
}

void TRPCBroker::RPCBMultSubscript (int i, int j, char * s);
{
    iRPCBMultSubscript( pRPC, i, j, s);
}

void TRPCBroker::RPCBMultPosition (int i, char * s, int j);
{
    iRPCBMultPosition( pRPC, i, s, j);
}

bool TRPCBroker::RPCBSilentLogin (void);
{
    iRPCBSilentLogin(pRPC);
}

void TRPCBroker::RPCBGetUserInfo (void);
{
    iRPCBGetUserInfo(pRPC);
}

void TRPCBroker::RPCBStartProgSLogin (char * s);
{
    iRPCBStartProgSLogin(s, pRPC);
}

bool TRPCBroker::RPCBCheckCmdLine (void);
{
    iRPCBCheckCmdLine(pRPC);
}

void TRPCBroker::RPCBGetServerInfo (char * s, char * t, int i);
{
    iRPCBGetServerInfo(s, t, i);
}

void TRPCBroker::RPCBPiece (char * s, char * t, int i, char * u);
{
    iRPCBPiece(s, t, i, u)
}

void TRPCBroker::RPCBTranslate (char * s, char * t, char * u, char * v);
{
    iRPCBTranslate(s, t, u, v);
}

void TRPCBroker::RPCBEncode (char * normaltext, char * value);
{
    iRPCBEncode(normaltext, value);
}

void TRPCBroker::RPCBEncode (char * encodedtext, char *value);
{
    iRPCBDecode(encodedtext, value);   
}


TRPCBroker::TRPCBroker()
{
   hLib = LoadLibrary(bapiDll);
   if((unsigned)hLib<=HINSTANCE_ERROR)
   	{
      char bfr[40];
      wsprintf(bfr, "Failure loading library: %s", bapiDll);
      MessageBox(NULL, bfr, toolSet, MB_OK|MB_APPLMODAL);
      UnLoad = true;
      }

   //
   // Get all the entry points for the functions we wish to test. Typedef's can
   // be used to simplify casting the return value from GetProcAddress.
   //
  iMySsoToken = (void *(__stdcall*)()) GetProcAddress(hLib, "MySsoToken");
  iRPCBCreate = (void *(__stdcall*)()) GetProcAddress(hLib, "RpcbCreate");
  iRPCBFree = (void (__stdcall*)(void *)) GetProcAddress(hLib, "RpcbFree");
  iRPCBCall = (char *(__stdcall*)(void *, char *)) GetProcAddress(hLib, "RpcbCall");
  iRPCBCreateContext = (bool (__stdcall*)(void *, char *)) GetProcAddress(hLib, "RpcbCreateContext");
  iRPCBMultSet = (void (__stdcall*)(void *, int, char *, char *)) GetProcAddress(hLib, "RpcbMultSet");
  iRPCBParamGet = (void (__stdcall*)(void *, int, int, char *)) GetProcAddress(hLib, "RpcbParamGet");
  iRPCBParamSet = (void (__stdcall*)(void *, int, int, char *)) GetProcAddress(hLib, "RpcbParamSet");
  iRPCBPropGet = (void (__stdcall*)(void *, char *, char *)) GetProcAddress(hLib, "RpcbPropGet");
  iRPCBPropSet =(void (__stdcall*)(void *, char *, char *)) GetProcAddress(hLib, "RpcbPropSet");
  iRPCBMultItemGet = (void (__stdcall*)(void *, int, char *, char *)) GetProcAddress(hLib,"RpcbMultItemGet");
  iRPCBMultPropGet = (void (__stdcall*)(void *, int, char *, char *)) GetProcAddress(hLib,"RpcbMultPropGet");
  iRPCBMultSortedSet = (void(__stdcall*)(void *, int, bool)) GetProcAddress(hLib, "RpcbMultSortedSet");
 //
  iRPCBLoginPropGet = (void(__stdcall *) (void *, char *, char *)) GetProcAddress(hLib, "RpcbLoginPropGet");
  iRPCBLoginPropSet = (void(__stdcall *) (void *, char *, char *)) GetProcAddress(hLib, "RpcbLoginPropSet");
  iRPCBUserPropGet = (void(__stdcall *) (void *, char *, char *)) GetProcAddress(hLib, "RpcbUserPropGet");
  iRPCBUserPropSet = (void(__stdcall *) (void *, char *, char *)) GetProcAddress(hLib, "RpcbUserPropSet");
  iRPCBMultOrder = (void(__stdcall *) (void *, int, char *, int, char *)) GetProcAddress(hLib, "RpcbMultOrder");
  iRPCBMultSubscrip = (void(__stdcall *) (void *, int, int, char *)) GetProcAddress(hLib, "RpcbMultSubscript");
  iRPCBMultPosition = (void(__stdcall *) (void *, int, char *, int)) GetProcAddress(hLib, "RpcbMultPosition");
  iRPCBSilentLogin = (bool(__stdcall *) (void *)) GetProcAddress(hLib, "RpcbSilentLogin");
  iRPCBGetUserInfo = (void(__stdcall *) (void *)) GetProcAddress(hLib, "RpcbGetUserInfo");
  iRPCBStartProgSLogin = (void(__stdcall *) (char *, void *)) GetProcAddress(hLib, "RpcbStartProgSLogin");
  iRPCBCheckCmdLine = (bool(__stdcall *) (void *)) GetProcAddress(hLib, "RpcbCheckCmdLine");
  iRPCBGetServerInfo = (void(__stdcall *) (char *, char *, int)) GetProcAddress(hLib, "RpcbGetServerInfo");
  iRPCBPiece = (void(__stdcall *) (char *, char *, int, char *)) GetProcAddress(hLib, "RpcbPiece");
  iRPCBTranslate = (void(__stdcall *) (char *, char *, char *, char *)) GetProcAddress(hLib, "RpcbTranslate");
  iRPCBEncode = (void(__stdcall *) (char *, char *)) GetProcAddress(hLib, "RPCBEncode");
  iRPCBDecode = (void(__stdcall *) (char *, char *)) GetProcAddress(hLib, "RPCBDecode");
 
 
   // GetProcAddress returns null on failure
   //
   if( iMySsoToken == NULL
   || if( iRPCBCreate == NULL || iRPCBFree == NULL || iRPCBCall == NULL || iRPCBCreateContext == NULL
   || iRPCBMultSet == NULL || iRPCBParamGet == NULL || iRPCBParamSet == NULL || iRPCBPropGet == NULL
   || iRPCBPropSet == NULL || iRPCBMultItemGet == NULL || iRPCBMultPropGet == NULL
   || iRPCBMultSortedSet == NULL || iRPCBLoginPropGet == NULL || iRPCBLoginPropSet == NULL
   || iRPCBUserPropGet == NULL || iRPCBUserPropSet == NULL || iRPCBMultOrder == NULL
   || iRPCBMultPosition == NULL || iRPCBSilentLogin == NULL || iRPCBGetUserInfo == NULL
   || iRPCBStartProgSLogin == NULL || iRPCBCheckCmdLine == NULL || iRPCBGetServerInfo == NULL
   || iRPCBPiece == NULL || iRPCBTranslate == NULL || iRPCBEncode == NULL || iRPCBDecode == NULL)
		{
      MessageBox(NULL, "Failure locating procedures.", toolSet,
            MB_OK|MB_APPLMODAL);
      UnLoad = true;
      }
   UnLoad = false;
   pRPC = iRPCBCreate();
};

TRPCBroker::~TRPCBroker()
{
	iRPCBFree(pRPC);
   FreeLibrary(hLib);
	UnLoad = true;
};


