﻿using System;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Microsoft.VisualBasic;
using System.Collections.Generic;
using System.Text;

namespace brokerDemo
{
    public partial class Form1 : Form
    {

        [DllImport("bapi32.dll")]
        public static extern void RpcbCall(int intRpcbHandle, byte[] strCallResult);

        [DllImport("bapi32.dll")]
        public static extern int RpcbCreate();

        [DllImport("bapi32.dll")]
        public static extern short RpcbCreateContext(int intRpcbHandle, string strContext);

        [DllImport("bapi32.dll")]
        public static extern void RpcbGetUserInfo(int intRpcbHandle);

        [DllImport("bapi32.dll")]
        public static extern void RpcbFree(int intRpcbHandle);

        [DllImport("bapi32.dll")]
        public static extern void RpcbMultItemGet(int intRpcbHandle, short intParIdx, string strSubscript, string strValue);

        [DllImport("bapi32.dll")]
        public static extern void RpcbPiece(string inputStr, string pieceDelim, int piecenum, byte[] strValue);

        [DllImport("bapi32.dll")]
        public static extern void RpcbMultPropGet(int intRpcbHandle, short intParIdx, string strProp, ref string strValue);

        [DllImport("bapi32.dll")]
        public static extern void RpcbMultSet(int intRpcbHandle, short intParIdx, string strSubscript, string strValue);

        [DllImport("bapi32.dll")]
        public static extern void RpcbMultSortedSet(int intRpcbHandle, short intParIdx, short intValue);

        [DllImport("bapi32.dll")]
        public static extern void RpcbParamGet(int intRpcbHandle, short intParIdx, byte[] intParTyp, byte[] intParVal);

        [DllImport("bapi32.dll")]
        public static extern void RpcbParamSet(int intRpcbHandle, short intParIdx, short intParTyp, string intParVal);

        [DllImport("bapi32.dll")]
        public static extern void RpcbPropGet(int intRpcbHandle, string strProp, byte[] strCallResult);

        [DllImport("bapi32.dll")]
        public static extern void RpcbPropSet(int intRpcbHandle, string strProp, string strValue);

        [DllImport("bapi32.dll")]
        public static extern void RpcbGetServerInfo(byte[] Server, byte[] Port, byte[] Value);

        public int intRpcbHandle;


        public Form1()
        {
            InitializeComponent();
        }
        public bool Connect(string server, string port)
        {
            if (intRpcbHandle == 0)
            {
                intRpcbHandle = RpcbCreate();
            }
            RpcbPropSet(intRpcbHandle, "CLEARPARAMETERS", "1");
            if (cbCertDialog.Checked)
                {
                    RpcbPropSet(intRpcbHandle, "SHOWCERTDIALOG", "1");
                }
            else
            {
                RpcbPropSet(intRpcbHandle, "SHOWCERTDIALOG", "0");
            }

            RpcbPropSet(intRpcbHandle, "Server", server);
            RpcbPropSet(intRpcbHandle, "ListenerPort", port);
            RpcbPropSet(intRpcbHandle, "Connected", "1");
            byte[] mBuffer = new byte[10];
            RpcbPropGet(intRpcbHandle, "Connected", mBuffer);
            string resultVal = System.Text.ASCIIEncoding.ASCII.GetString(mBuffer);
            resultVal = resultVal.Replace("\0", "");
            if (resultVal == "0") return false;
            RpcbCreateContext(intRpcbHandle, "XWB EGCHO");
            RpcbPropGet(intRpcbHandle, "CURRENTCONTEXT", mBuffer);
            string contextName = System.Text.ASCIIEncoding.ASCII.GetString(mBuffer);
            if (contextName == "")
            {
                return false;
            }
            else
            {
                return true;
            }
        
            }

            private void Button1_Click(object sender, EventArgs e)
        {
            button1.Enabled = false;
            byte[] serverInfo = new byte[1];
            byte[] sBuffer = new byte[30];
            byte[] pBuffer = new byte[30];
            RpcbGetServerInfo(sBuffer, pBuffer, serverInfo);
            string connServer = System.Text.ASCIIEncoding.ASCII.GetString(sBuffer);
            string connPort = System.Text.ASCIIEncoding.ASCII.GetString(pBuffer);
            var connected = Connect(connServer, connPort);
            if (connected == true)
            {
                toolStripStatusLabel1.Text = "Connected";
                resultBox.Clear();
                byte[] mBuffer = new byte[100];
                RpcbPropGet(intRpcbHandle, "Server", mBuffer);
                string lSName = System.Text.ASCIIEncoding.ASCII.GetString(mBuffer);
                RpcbPropGet(intRpcbHandle, "ListenerPort", mBuffer);
                string lPort = System.Text.ASCIIEncoding.ASCII.GetString(mBuffer);
                RpcbPropGet(intRpcbHandle, "Connected", mBuffer);
                string lConn = System.Text.ASCIIEncoding.ASCII.GetString(mBuffer);
                if (!String.IsNullOrEmpty(lConn)) { lConn = "True"; }
                RpcbPropGet(intRpcbHandle, "SSOILOGONNAME", mBuffer);
                string lLogName = System.Text.ASCIIEncoding.ASCII.GetString(mBuffer);
                RpcbPropGet(intRpcbHandle, "BrokerVersion", mBuffer);
                string lVersion = System.Text.ASCIIEncoding.ASCII.GetString(mBuffer);
                RpcbPropGet(intRpcbHandle, "SSOiSECId", mBuffer);
                string lSECId = System.Text.ASCIIEncoding.ASCII.GetString(mBuffer);
                RpcbPropGet(intRpcbHandle, "SSOiADUPN", mBuffer);
                string lADUPN = System.Text.ASCIIEncoding.ASCII.GetString(mBuffer);
                var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
                var stringChars = new char[8];
                var random = new Random();
                for (int i = 0; i < stringChars.Length; i++)
                {
                    stringChars[i] = chars[random.Next(chars.Length)];
                }
                var finalString = new String(stringChars);
                byte[] getValue = new byte[100];
                byte[] PType = new byte[10];
                RpcbParamSet(intRpcbHandle, 0, 1, finalString);
                RpcbParamGet(intRpcbHandle, 0, PType, getValue);
                string getVal = System.Text.ASCIIEncoding.ASCII.GetString(getValue);
                getVal = getVal.Replace("\0", "");
                if (String.IsNullOrEmpty(getVal)) { getVal = "Invalid reference"; }
                resultBox.AppendText("Server: " + lSName);
                resultBox.AppendText("\r\n");
                resultBox.AppendText("Port: " + lPort);
                resultBox.AppendText("\r\n");
                resultBox.AppendText("Connected: " + lConn);
                resultBox.AppendText("\r\n");
                resultBox.AppendText("SSOi login name: " + lLogName);
                resultBox.AppendText("\r\n");
                resultBox.AppendText("RPC Broker version: " + lVersion);
                resultBox.AppendText("\r\n");
                resultBox.AppendText("SSOi SECId: " + lSECId + "\t\tSSOi ADUPN: " + lADUPN);
                resultBox.AppendText("\r\n");
                resultBox.AppendText("Randomly generated string:" + finalString);
                resultBox.AppendText("\r\n");
                resultBox.AppendText("Retrieved value: " + getVal);
                resultBox.AppendText("\r\n");
                resultBox.AppendText("\r\n");
                resultBox.AppendText("User Information:");
                resultBox.AppendText("\r\n");
                button2.Enabled = true;
                RpcbPropSet(intRpcbHandle, "CLEARPARAMETERS", "1");
                var rBuffer = new byte[1024];
                RpcbGetUserInfo(intRpcbHandle);
                RpcbPropGet(intRpcbHandle, "RESULTS", rBuffer);
                string data = System.Text.ASCIIEncoding.ASCII.GetString(rBuffer);
                data = data.Replace("\0", "");
                string[] lines = System.Text.RegularExpressions.Regex.Split(data, "\r\n");
                foreach (string line in lines)
                {
                    resultBox.AppendText(line + "\r\n");
                }
                button4.Enabled = true;
            }
            else
            {
                button1.Enabled = true;
                MessageBox.Show("Failed to login to server", "Login failure");
                RpcbPropSet(intRpcbHandle, "CLEARPARAMETERS", "1");
                
            }
        }

        private void Button2_Click(object sender, EventArgs e)
        {
            if (intRpcbHandle != 0)
            {
                RpcbPropSet(intRpcbHandle, "Connected", "0");
                resultBox.Clear();
                lbRPC.Items.Clear();
                toolStripStatusLabel1.Text = "Disconnected";
                button4.Enabled = false;
                button2.Enabled = false;
                button1.Enabled = true;
            }
        }

        private void Button3_Click(object sender, EventArgs e)
        {
            if (intRpcbHandle != 0)
            {
                RpcbPropSet(intRpcbHandle, "Connected", "0");
                resultBox.Clear();
                System.Environment.Exit(1);
            }
            System.Environment.Exit(1);
        }

        private void Button4_Click(object sender, EventArgs e)
        {
            lbRPC.Items.Clear();
            RpcbPropSet(intRpcbHandle, "CLEARPARAMETERS", "1");
            RpcbPropSet(intRpcbHandle, "CLEARRESULTS", "1");
            RpcbPropSet(intRpcbHandle, "RemoteProcedure", "XWB FILE LIST");
            string input = Interaction.InputBox("Start with name", "FILE list", "A", -1, -1);
            if (input == "") { return; }
            RpcbParamSet(intRpcbHandle, 0, 0, input.ToUpper());
            //RpcbParamSet(intRpcbHandle, 1, 0, "1");
            var rpcBuffer = new byte[30000000];
            var pBuffer = new byte[5000];
            RpcbCall(intRpcbHandle, rpcBuffer);
            RpcbPropGet(intRpcbHandle, "RESULTS", rpcBuffer);
            string rpcData = System.Text.ASCIIEncoding.ASCII.GetString(rpcBuffer);
            rpcData = rpcData.Replace("\0", "");
            string[] rpcLines = System.Text.RegularExpressions.Regex.Split(rpcData, "\r\n");
            for (var i = 0; i < rpcLines.Length - 1; i++)
            {
                //if (rpcLines[i].IndexOf("^") > 0)
                {
                    //var piece = rpcLines[i].Substring(rpcLines[i].IndexOf("[") + 1, rpcLines[i].IndexOf("]") - rpcLines[i].IndexOf("[") - 1);
                    //RpcbPiece(rpcLines[i], "^", 2, pBuffer);
                    lbRPC.Items.Add(rpcLines[i]);

                }

            }

        }
    }
}

